{ |          Construction Unit for TurboDraw 256 Pro       | }
{ |       Programmed by Kiselev Anton (Masacre Ant)        | }
{ |TDraw can be used for constructing on screen all images | }
{ |                   with *.tdi extension"                | }

{----------------------User Reference------------------------
   For Drawing of simple images use commands:
   * DRAW(name:string);
   * EXAMPLE:  ...
              draw('images\banan.tdi');
               ...
   For Drawing of extended images use commands:
   * EXTDRAW(name:string; X,Y:integer; trnspcol:word);
   * EXAMPLE:  ...
              extdraw('images\banan.tdi',10,10,7);
               ...
}

unit TDraw;

 INTERFACE
  uses Graph;
  var tx,ty:integer; tbrush,tbrprop,tcol,tscol:byte; tsavebufer:text;
      fileerror:boolean;

  procedure build;
  procedure draw(name:string);
  procedure extdraw(name:string; x,y:integer; trnspcol:integer);

 IMPLEMENTATION


  procedure build;
   var i:integer;
       radis:integer;
   begin
     if tbrush=1 then begin
     SetFillStyle(1,tcol);
        if (tbrprop<>1)and(tbrprop<>3)and(tbrprop<>5) then
         bar(tx-(tbrprop div 2),ty-(tbrprop div 2),tx+(tbrprop div 2),ty+(tbrprop div 2));
        if (tbrprop=1)or(tbrprop=3)or(tbrprop=5) then
         bar (tx,ty,tx+tbrprop,ty+tbrprop);
       end;
    if tbrush=2 then begin
     randomize;
      for i:= 1 to 3 do begin
         putpixel(tx+random(tbrprop+5),ty+random(tbrprop+5),tcol);
         putpixel(tx-random(tbrprop+5),ty-random(tbrprop+5),tcol);
         putpixel(tx-random(tbrprop+5),ty+random(tbrprop+5),tcol);
         putpixel(tx+random(tbrprop+5),ty-random(tbrprop+5),tcol);
           end;
       end;
    if tbrush=3 then begin
     setcolor(tscol);
      {main fill actions}
       rectangle(45,45,505,405);
       SetFillStyle(1,tcol);
          FloodFill(tx,ty,tscol);
      {end}
     setcolor(63);
       end;
    if tbrush=4 then begin
     SetFillStyle(1,7);
        if (tbrprop<>1)and(tbrprop<>3)and(tbrprop<>5) then
         bar (tx-(tbrprop div 2),ty-(tbrprop div 2),tx+(tbrprop div 2),ty+(tbrprop div 2));
        if (tbrprop=1)or(tbrprop=3)or(tbrprop=5) then
         bar (tx,ty,tx+tbrprop,ty+tbrprop);
       end;
    if tbrush=5 then begin
     radis:=tbrprop;
     setfillstyle(1,tcol);
     setcolor(tcol);
     Circle(tx,ty,tbrprop);
     floodfill(tx,ty,tcol);
     while radis>-1 do begin
      radis:=radis-1;
      Circle(tx,ty,radis);
        end;
     setcolor(63);
       end;
  end;

  procedure draw(name:string);
   begin
    Assign(tsavebufer,name);
     reset(tsavebufer);
      while eof(tsavebufer)=false do
       begin
        readln(tsavebufer,tbrush,tcol,tx,ty,tbrprop,tscol);
        build;
        end;
    Close(tsavebufer);
   end;

  procedure extdraw(name:string; x,y:integer; trnspcol:integer);
   var pixcolor,px,py:integer;
   begin
    Assign(tsavebufer,name);
     {$I-}
    reset(tsavebufer);
     {$I+}
    if IOResult=0 then begin

     fileerror:=false;
     readln(tsavebufer);

       while not eof(tsavebufer) do
        begin
         readln(tsavebufer,px,py,pixcolor);
         if pixcolor<>trnspcol then  putpixel(x+px,y+py,pixcolor);
        end;
      end else fileerror:=true;
   end;

begin
end.